package com.tripto.bjlt;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import org.quartz.JobBuilder;
import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.SchedulerException;
import org.quartz.SchedulerFactory;
import org.quartz.SimpleScheduleBuilder;
import org.quartz.Trigger;
import org.quartz.TriggerBuilder;
import org.quartz.impl.StdSchedulerFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.tripto.bjlt.interfaces.SpiderSearchRpc;
import com.tripto.bjlt.job.StatisticsJob;
import com.tripto.bjlt.utils.RedisCacheUtil;
import com.tripto.bjlt.utils.RedisUtil;
import com.tripto.bjlt.utils.SpiderSearchUtils;

public class InitServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
	 //创建调度器
    public static Scheduler getScheduler() throws SchedulerException{
        SchedulerFactory schedulerFactory = new StdSchedulerFactory();
        return schedulerFactory.getScheduler();
    }
    
	 @Override  
	 public void init(ServletConfig config) throws ServletException {  
	     super.init(config);
	     //contro_code = 0 测试
	     String contro_code = config.getInitParameter("contro_code");
	     System.out.println("============初始化=指定CONTRO_CODE:"+contro_code+"===========");
	     if(contro_code != null && contro_code.equals("0")) {
   	    	ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Contro_dubbo_Sv0.xml"});
      	    context.start();
      	    System.out.println("-------------Contro_dubbo_Sv0启动成功----");
	   	 }else if(contro_code != null && contro_code.equals("1")) {
   	    	ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Contro_dubbo_Sv1.xml"});
      	    context.start();
      	    System.out.println("-------------Contro_dubbo_Sv1启动成功----");
   	     }else if(contro_code != null && contro_code.equals("2")) {
	    	ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Contro_dubbo_Sv2.xml"});
      	    context.start();
      	    System.out.println("-------------Contro_dubbo_Sv2启动成功----");
   	     }else if(contro_code != null && contro_code.equals("3")) {
	    	ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Contro_dubbo_Sv3.xml"});
      	    context.start();
      	    System.out.println("-------------Contro_dubbo_Sv3启动成功----");
   	     }else if(contro_code != null && contro_code.equals("4")) {
	    	ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Contro_dubbo_Sv4.xml"});
      	    context.start();
      	    System.out.println("-------------Contro_dubbo_Sv4启动成功----");
   	     }else if(contro_code != null && contro_code.equals("5")) {
	    	ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Contro_dubbo_Sv5.xml"});
      	    context.start();
      	    System.out.println("-------------Contro_dubbo_Sv5启动成功----");
   	     }
   	     ClassPathXmlApplicationContext context= new ClassPathXmlApplicationContext(new String[] {"Search_dubbo_Cv.xml"});
   	     
   	     context.start();
   	     System.out.println("--------------Search_dubbo_Cv启动成功----------");
   	     SpiderSearchRpc searchRpc = (SpiderSearchRpc)context.getBean("SpiderSearchRpc");
   	     if(searchRpc != null) {
   	    	SpiderSearchUtils.init(searchRpc,contro_code);
   	    	System.out.println("--------------SpiderSearchRpc获取成功----------");
   	     }
   	     //初始化Redis
   	    String redis_cache_address = config.getInitParameter("redis_cache_address");
	   	int redis_cache_port = Integer.valueOf(config.getInitParameter("redis_cache_port"));
	   	String redis_cache_pwd = config.getInitParameter("redis_cache_pwd");
	   	int redis_cache_max_active = Integer.valueOf(config.getInitParameter("redis_cache_max_active"));
	   	int redis_cache_max_idle = Integer.valueOf(config.getInitParameter("redis_cache_max_idle"));
	   	int redis_cache_max_wait = Integer.valueOf(config.getInitParameter("redis_cache_max_wait"));
	   	int redis_cache_timeout = Integer.valueOf(config.getInitParameter("redis_cache_timeout"));
	   	
	   	RedisCacheUtil.Init(redis_cache_address,redis_cache_port,redis_cache_pwd,redis_cache_max_active,redis_cache_max_idle,redis_cache_max_wait,redis_cache_timeout);
	    System.out.println("-----------------缓存Redis初始化成功-----------------");
	    ControManage.StartLoad();
   	    System.out.println("-----------------初始化加载缓存-------------------");
   	    
	    String redis_address = config.getInitParameter("redis_address");
	   	int redis_port = Integer.valueOf(config.getInitParameter("redis_port"));
	   	String redis_pwd = config.getInitParameter("redis_pwd");
	   	int redis_max_active = Integer.valueOf(config.getInitParameter("redis_max_active"));
	   	int redis_max_idle = Integer.valueOf(config.getInitParameter("redis_max_idle"));
	   	int redis_max_wait = Integer.valueOf(config.getInitParameter("redis_max_wait"));
	   	int redis_timeout = Integer.valueOf(config.getInitParameter("redis_timeout"));
   	    RedisUtil.Init(redis_address,redis_port,redis_pwd,redis_max_active,redis_max_idle,redis_max_wait,redis_timeout);
   	    System.out.println("-----------------Redis初始化成功-----------------");
   	    
   	     try {
   	    	JobDetail jobDetail = JobBuilder.newJob(StatisticsJob.class).withIdentity("job1", "group1").build();
	  	      //创建触发器 每3秒钟执行一次
	  	      Trigger trigger = TriggerBuilder.newTrigger().withIdentity("trigger0", "group0")
	  	                          .withSchedule(SimpleScheduleBuilder.simpleSchedule().withIntervalInSeconds(60).repeatForever())
	  	                          .build();
	  	      Scheduler scheduler = getScheduler();
	  	      //将任务及其触发器放入调度器
	  	      scheduler.scheduleJob(jobDetail, trigger);
	  	      //调度器开始调度任务
	  	      scheduler.start();
			} catch (Exception e) {
				e.printStackTrace();
			}
   	  System.out.println("-----------------定时任务StatisticsJob启动成功-----------------");
   	     
	 }
}
