package com.tripto.bjlt.service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.util.RespEntity;
import com.tripto.bjlt.ControManage;
import com.tripto.bjlt.entity.SearchResultSet;
import com.tripto.bjlt.utils.RedisUtil;
import com.tripto.bjlt.utils.SpiderSearchUtils;

/**
 * 全局委托模式
 * @ClassName: SearchEntrustService 
 * @Description: TODO(这里用一句话描述这个类的作用) 
 * @author zhangqifei 
 * @date 2018年4月13日 上午10:42:06
 */
public class SearchEntrustService {

	public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	
	/**
	 * 查询委托 回调结果归还给对应的查询需求
	 */
	public static Map<String, Map<String,SearchService>> searchEntrust = new HashMap<String, Map<String,SearchService>>();
	
	/**
	 * 发送查询
	 * @param searchList
	 */
	public static void SendOutSeaarch(SearchRequestEntity search) {
		String key = search.getQueneName()+"_"+search.getFormCity()+"_"+search.getToCity()+"_"+search.getTripType();
		key +="_"+search.getFromDate()+"_"+search.getRetDate();
		SearchLogService.Statistics(key, 11);//爬虫收集   航司数据源_出发站_到达站_行程类型_出发时间_到达时间
		SearchTread st = new SearchTread(search);
		st.start();
//		RespEntity re = SpiderSearchUtils.search(search);
//		if(re.status == 200) {
//			//发送成功
//			SearchLogService.Statistics(search.getQueneName(), 2);//2.爬虫发送收集 成功
//		}else {
//			//发送失败
//			SearchLogService.Statistics(search.getQueneName(), 3);//3.爬虫发送收集 失败
//		}
		SearchLogService.Statistics(search.getQueneName(), 2);//2.爬虫发送收集 成功
	}
	
	
	
	/**
	 * 查询结果统一回调入口
	 * @param see
	 */
	public static void ResultCallback(SearchResponseEntity result){
		//result suitAge 适用乘客年级，可以为空，   储藏查询获取时间
		result.setSuitAge(sdf.format(new Date()));
		result.getData();
		//校验结果是否存在，单程校验是否又数据  往返判断去程与返程数据是否存在
		if(result != null && result.getFromSegments() != null && result.getFromSegments().size() > 0) {
			String airName = result.getQueneName();//获取航司编码
			String airSource = result.getFromSegments().get(0).getAirSourceName();
			SearchLogService.Statistics(airSource, 4);//4.爬虫回调收集
			//组装KEY  AK_WEB_KUL_DPS_2_3_20180506_20180520
			if(result.getRetDate() == null) {
				result.setRetDate("");
			}
			String key = airSource+"_"+result.getFormCity()+"_"+result.getToCity()+"_"+result.getTripType()+"_"+result.getAdultNum()+"_"+result.getFromDate()+"_"+result.getRetDate();
			System.out.println("查询结果回调："+key);
			addRedis(airName,key,result);//入redis
			//在全局中查找是否有未处理的保持15s等待  赋予结果    (SearchResultSet)resultSet.clone()
			if(searchEntrust.containsKey(key)) {
				for(String uuid:searchEntrust.get(key).keySet()){
					searchEntrust.get(key).get(uuid).ResultCallBack(key,(SearchResponseEntity)result.clone());
				}
				searchEntrust.remove(key);//直接删除
			}
		}else {
			//数据不正常，直接抛弃
		}
	}
	
	/**
	 * 添加到Redis缓存  如果是往返进行拆分，并且匹配缓存时效时长 秒   建议结果压缩，减少redis存储空间 暂时先不做拆解 保留思想  暂时不对内容进行加密
	 * @param airName
	 * @param key
	 * @param result
	 */
	public static void addRedis(String airName,String key,SearchResponseEntity result) {
		int duration = ControManage.CalculationDuration(airName, result.getFromDate(), result.getRetDate(),result.getFormCity(),result.getToCity());//计算缓存时长
		RedisUtil.addRedis(key, JSON.toJSONString(result), duration);
	}
	
	/**
	 * 查询Redis  
	 * @param key 如：AK_WEB_KUL_DPS_2_3_20180506_20180520
	 * @return
	 */
	public static SearchResponseEntity QueryRedis(String key){
		String sr = RedisUtil.getRedis(key);
		if(sr != null && !sr.equals("")) {
			System.out.println("取到缓存数据："+key);
			SearchResponseEntity responseEntity = JSONObject.toJavaObject(JSON.parseObject(sr), SearchResponseEntity.class);
			SearchLogService.Statistics(responseEntity.getSearchId(), 5);//5.命中缓存数统计
			return responseEntity;
		}else {
			return null;
		}
	}
	
	/**
	 * 查询等待结束后需要释放一下
	 * @param key
	 * @param uuid
	 */
	public static void deleteSearchEntrust(String key,String uuid) {
		if(searchEntrust.containsKey(key)) {
			if(searchEntrust.get(key).size() > 1) {
				searchEntrust.get(key).remove(uuid);
			}else {
				searchEntrust.remove(key);
			}
		}
	}
	
	/**
	 * 挂着查询
	 * @param key
	 * @param uuid
	 * @param ss
	 * @return
	 */
	public static boolean addSearchEntrust(String key,String uuid,SearchService ss) {
		if(SearchEntrustService.searchEntrust.containsKey(key)) {
			SearchEntrustService.searchEntrust.get(key).put(uuid, ss);
			return true;
		}else {
			Map<String,SearchService> map = new HashMap<>();
			map.put(uuid, ss);
			SearchEntrustService.searchEntrust.put(key, map);//加入等待队列
			return false;
		}
	}
}
