package com.tripto.bjlt.service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import javax.jms.JMSException;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.tripto.bjlt.utils.ActiveMQUtil;
import com.tripto.bjlt.utils.RedisUtil;

import lombok.extern.slf4j.Slf4j;

/**
 * 查询Log服务
 * @ClassName: SearchLogService 
 * @Description: TODO(这里用一句话描述这个类的作用) 
 * @author zhangqifei 
 * @date 2018年4月16日 上午10:34:40
 */
@Slf4j
public class SearchLogService {
	
	//发送地址
	public static String url = "tcp://120.78.160.252:61616";
	public static String QUEUE_NAME = "ControStatistics";
	
	//API收集
	//1.API收集请求数（分平台）
	public static Map<String, Integer> requestAPICount = new HashMap<>();
	
	//2.收集爬虫请求数（分航司）发送成功 发送失败  结果回调  命中缓存数
	public static Map<String,Integer[]> spdierCount = new HashMap<>(); 

	//详细收集
	//1.API记录请求数据   出发站_到达站_行程类型_出发时间_到达时间    KEY   统计请求数
	public static Map<String,Integer> apiDetailedCount = new HashMap<>();
	
	//2.爬虫收集   航司数据源_出发站_到达站_行程类型_出发时间_到达时间             统计请求次数
	public static Map<String,Integer> spdierDetailedCount = new HashMap<>();
	
	//3.价格收集  KEY=AK_PEK_KUL_D7317_EC VALUE={KEY=记录记录时间,VALUE=成人票价,儿童票价}  这块功能下放放  后面在做
	public static Map<String,Map<Integer,String>> logTicketPrice = new HashMap<>();
	
	public static SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:00");//设置日期格式
	
	/**
	 * 记录模式
	 * @param key 
	 * @param type 1.api收集 2.爬虫发送收集 成功  3.爬虫发送收集 失败  4.爬虫回调收集   5.命中缓存数 10.详细收集 1.API记录请求数据  11.详细收集 1.爬虫收集
	 */
	public static void Statistics(String key,int type) {
		if(type == 1) {
			if(requestAPICount.containsKey(key)) {
				requestAPICount.put(key, requestAPICount.get(key)+1);
			}else {
				requestAPICount.put(key,1);
			}
		}else if(type == 2) {
			if(spdierCount.containsKey(key)) {
				spdierCount.get(key)[0] = spdierCount.get(key)[0]+1;
			}else {
				spdierCount.put(key, new Integer[] {1,0,0,0});
			}
		}else if(type == 3) {
			if(spdierCount.containsKey(key)) {
				spdierCount.get(key)[1] = spdierCount.get(key)[1]+1;
			}else {
				spdierCount.put(key, new Integer[] {0,1,0,0});
			}
		}else if(type == 4) {
			if(spdierCount.containsKey(key)) {
				spdierCount.get(key)[2] = spdierCount.get(key)[2]+1;
			}else {
				spdierCount.put(key, new Integer[] {0,0,1,0});
			}
		}else if(type == 5) {
			if(spdierCount.containsKey(key)) {
				spdierCount.get(key)[3] = spdierCount.get(key)[3]+1;
			}else {
				spdierCount.put(key, new Integer[] {0,0,0,1});
			}
		}else if(type == 10) {
			if(apiDetailedCount.containsKey(key)) {
				apiDetailedCount.put(key, apiDetailedCount.get(key)+1);
			}else {
				apiDetailedCount.put(key,1);
			}
		}else if(type == 11) {
			if(spdierDetailedCount.containsKey(key)) {
				spdierDetailedCount.put(key, spdierDetailedCount.get(key)+1);
			}else {
				spdierDetailedCount.put(key,1);
			}
		}
	}
	
	/**
	 * 1分钟执行一次，把统计结果发送MQ
	 */
	public static void QuartzJob() {
		JSONArray array = new JSONArray();
		String dateTime = df.format(new Date());//记录当前统计时间
		String cacheNum = "0";
		try {
			cacheNum = RedisUtil.countKey()+"";//统计当前缓存数量	
		} catch (Exception e) {
			e.printStackTrace();
		}
		int entrustNum = SearchEntrustService.searchEntrust.size();//委托的当前数量
		for(String key:spdierCount.keySet()) {
			JSONObject json = new JSONObject();
			json.put("record_datetime",dateTime);
			json.put("cache_date_count",cacheNum);
			json.put("entrust_num",entrustNum);
			json.put("air_name",key);
			json.put("spdier_send_success",spdierCount.get(key)[0]);
			json.put("spdier_send_fail",spdierCount.get(key)[1]);
			json.put("spdier_callback",spdierCount.get(key)[2]);
			json.put("hit_cache_num",spdierCount.get(key)[3]);
			array.add(json);
		}
		//清空记录
		requestAPICount = new HashMap<>();
		spdierCount = new HashMap<>(); 
		try {
			log.info("1分钟统计结果：" + array);
			if(array.size() > 0) {
				System.out.println(array);
				ActiveMQUtil.sendMessage(url, QUEUE_NAME, array.toJSONString());	
			}
		} catch (JMSException e) {
			e.printStackTrace();
		}
	}
	
}
