package com.tripto.bjlt.utils;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;


/**
 * @Description: 发送get和post请求
 * @author zhangqifei
 * @date 2016年11月14日 下午2:52:09
 */

public class HttpUtil {

	/**
	 * java.net实现 HTTP或HTTPs GET方法提交
	 * @param strUrl  提交的地址及参数
	 * @return 返回的response信息
	 */
	public static String submitGet(String strUrl) {
		URLConnection connection = null;
		BufferedReader reader = null;
		String str = null;
		try {
			URL url = new URL(strUrl);
			connection = url.openConnection();
			connection.setConnectTimeout(5000);
			connection.setReadTimeout(5000);
			connection.setDoInput(true);
			connection.setDoOutput(false);
			// 取得输入流，并使用Reader读取
			reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
			String lines;
			StringBuffer linebuff = new StringBuffer("");
			while ((lines = reader.readLine()) != null) {
				linebuff.append(lines);
			}
			str = linebuff.toString();
		} catch (Exception e) {
			e.printStackTrace();
			//logger.info("出现连接超时异常了。", e);
			str = "请求异常";
		} finally {
			try { 
				reader.close();
			} catch (Exception e) {
				//logger.info("出现空指针异常了。", e);
			}
		}
		return str;
	}
	
	/**
	 * java.net实现 HTTP或HTTPs GET方法提交
	 * @param strUrl  提交的地址及参数
	 * @return 返回的response信息
	 */
	public static String submitGet(String strUrl,String code,int timeout) {
		URLConnection connection = null;
		BufferedReader reader = null;
		String str = null;
		try {
			URL url = new URL(strUrl);
			connection = url.openConnection();
			connection.setConnectTimeout(timeout);
			connection.setReadTimeout(timeout);
			connection.setDoInput(true);
			connection.setDoOutput(false);
			// 取得输入流，并使用Reader读取
			reader = new BufferedReader(new InputStreamReader(connection.getInputStream(),code));
			String lines;
			StringBuffer linebuff = new StringBuffer("");
			while ((lines = reader.readLine()) != null) {
				linebuff.append(lines);
			}
			str = linebuff.toString();
		} catch (Exception e) {
			// e.printStackTrace();
			//logger.info("出现连接超时异常了。", e);
			str = "异常";
		} finally {
			try { 
				reader.close();
			} catch (Exception e) {
				//logger.info("出现空指针异常了。", e);
			}
		}
		return str;
	}

	/**
	 * java.net实现 HTTP POST方法提交
	 * @param url
	 * @param paramContent
	 * @return
	 */
	public static StringBuffer submitPost(String url, String paramContent,
			String codetype) {
		StringBuffer responseMessage = null;
		java.net.URLConnection connection = null;
		java.net.URL reqUrl = null;
		OutputStreamWriter reqOut = null;
		InputStream in = null;
		BufferedReader br = null;
		try {
			String param = paramContent;
			// System.out.println("url=" + url + "?" + paramContent + "\n");
			// System.out.println("===========post method start=========");
			responseMessage = new StringBuffer();
			reqUrl = new java.net.URL(url);
			connection = reqUrl.openConnection();
			connection.setRequestProperty("Accept-Charset", codetype);
			connection.setRequestProperty("contentType", codetype);
			connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
			connection.setConnectTimeout(10*1000);
			connection.setReadTimeout(10*1000);
			connection.setDoOutput(true);
			reqOut = new OutputStreamWriter(connection.getOutputStream(),codetype);
			reqOut.write(param);
			reqOut.flush();
			int charCount = -1;
			in = connection.getInputStream();

			br = new BufferedReader(new InputStreamReader(in, codetype));
			while ((charCount = br.read()) != -1) {
				responseMessage.append((char) charCount);
			}
		} catch (Exception ex) {
			responseMessage.append("异常");
			ex.printStackTrace();
		} finally {
			try {
				br.close();
				in.close();
				reqOut.close();
			} catch (Exception e) {
				System.out.println("paramContent=" + paramContent + "|err=" + e);
			}
		}
		return responseMessage;
	}
	
	public static void main(String[] args){
		String url = "http://128.14.30.202:31001/Statistics/getStatisticsResult";
	    System.out.println(submitPost(url, "", "UTF-8"));
	}
	
}
